public stock const AUTHOR[] = "Emma Jule";
public stock const VERSION[] = "1.0.0";

#include <amxmodx>
#include <fakemeta>
#include <hamsandwich>
#include <reapi>

#define MINED_SAMPLE		"maps_sound/mined.wav"		// опционально
#define REVIVE_SAMPLE		"maps_sound/revive.wav"		// опционально


new const CORPSE_CLASSNAME[] = "info_corpse";

enum _:CVARS
{
	ACCESS[32],
	Float:DURATION,
	MAX,
	MAX_REVIVES,
	MAX_MINES,
	ROUND,
	Float:ROUND_TIME,
	Float:DISTANCE,
	Float:HEALTH,
	Float:ADD_HEALTH,
	MONEY,
	FRAG,
	GUN[512],
	BAR,
	BOMB,
	DUEL,
	VIP,
	CANT_FIRE,
	Float:SPEED,
	Float:DAMAGE,
	Float:ALPHA,
	
};	new CVAR[CVARS], g_iSpriteIndex, m_bBombPlanted;


enum _:CORPSE_DATA
{
	CORPSE_ID,
	REVIVES,
	MINES,
	
};	new eCorpseStruct[MAX_CLIENTS + 1][CORPSE_DATA];


public plugin_precache()
{
	CreateCvars();
	
	g_iSpriteIndex = precache_model("sprites/explode1.spr");
	
#if defined REVIVE_SAMPLE
	precache_sound(REVIVE_SAMPLE);
#endif

#if defined MINED_SAMPLE
	precache_sound(MINED_SAMPLE);
#endif
}

public plugin_init()
{
	register_plugin("Revive Players", VERSION, AUTHOR);
	
	register_message(get_user_msgid("ClCorpse"), "MsgHookClCorpse");
	register_event("TeamInfo", "Event_TeamInfo", "a", "1>0", "2!UNASSIGNED");
	
	RegisterHookChain(RG_PlantBomb, "CSGameRules_PlantBomb", true);
	RegisterHookChain(RG_CBasePlayer_Spawn, "CBasePlayer_Spawn", true);
	RegisterHookChain(RG_CSGameRules_CleanUpMap, "CSGameRules_CleanUpMap", true);
	
	RegisterHam(Ham_ObjectCaps, "info_target", "fw_ObjectCaps", false);
}

public Event_TeamInfo()
{
	CorpseRemove(read_data(1));
}

public client_disconnected(id)
{
	CorpseRemove(id);
}

public CBasePlayer_Spawn(const id)
{
	CorpseRemove(id);
}

public CBasePlayer_ResetMaxSpeed(id)
{
	if (~get_entvar(id, var_iuser3) & PLAYER_PREVENT_CLIMB)
		return;
	
	set_entvar(id, var_maxspeed, CVAR[SPEED]);
}

public CSGameRules_CleanUpMap()
{
	m_bBombPlanted = 0;
	
	new id = rg_find_ent_by_class(NULLENT, CORPSE_CLASSNAME);
	
	while (id > 0)
	{
		CorpseRemove(get_entvar(id, var_owner));
		
		id = rg_find_ent_by_class(id, CORPSE_CLASSNAME);
	}
}

public CSGameRules_PlantBomb()
{
	m_bBombPlanted = 1;
}

public fw_ObjectCaps(id)
{
	if (!FClassnameIs(id, CORPSE_CLASSNAME))
		return HAM_IGNORED;
	
	SetHamReturnInteger(FCAP_ONOFF_USE);
	return HAM_OVERRIDE;
}

@corpse_use(id, activator, caller, USE_TYPE:type, Float:value)
{
	if (get_member_game(m_bRoundTerminating))
		return;
	
	if (value == 0.0)
		return;
	
	if (is_nullent(id))
		return;
	
	if (activator != caller)
		return;
	
	if (!ExecuteHam(Ham_IsPlayer, activator))
		return;
	
	if (~get_user_flags(activator) & read_flags(CVAR[ACCESS]))
	{
		client_print_color(activator, print_team_red, "^3для доступа вам необходим доступ^4 %s", CVAR[ACCESS]);
		return;
	}
	
	if (get_member(activator, m_bIsVIP) && CVAR[VIP])
	{
		client_print_color(activator, print_team_red, "^3вы как VIP персона не можете это делать..");
		return;
	}
	
	static Float:flCurTime;
	flCurTime = get_gametime();
	if (flCurTime - Float:get_member_game(m_fRoundStartTime) < CVAR[ROUND_TIME])
	{
		client_print_color(activator, print_team_red, "^3слишком рано от начала раунда..");
		return;
	}
	
	if (m_bBombPlanted && CVAR[BOMB])
	{
		client_print_color(activator, print_team_red, "^3нельзя воскрешать когда бобма установленна..");
		return;
	}
	
	if (UTIL_Is_1v1() && CVAR[DUEL])
	{
		client_print_color(activator, print_team_red, "^3нельзя воскрешать когда остались один на один..");
		return;
	}
	
	// if (Float:get_entvar(id, var_nextthink))
	if (get_entvar(id, var_iuser1))
		return;
	
	if (get_entvar(activator, var_movetype) == MOVETYPE_FLY)
	{
		client_print_color(activator, print_team_red, "^3слезьте с лестницы..");
		return;
	}
	
	if (get_entvar(activator, var_waterlevel) > 1)
	{
		client_print_color(activator, print_team_red, "^3находясь в воде труп не востановишь..");
		return;
	}
	
	if (get_member(activator, m_iAccount) < CVAR[MONEY])
	{
		client_print_color(activator, print_team_red, "^3у вас недостаточно средств..");
		return;
	}
	
	new Float:vecVelocity[3];
	get_entvar(activator, var_velocity, vecVelocity);
	if (vector_length(vecVelocity) > 250.0)
		return;
	
	if (get_member((caller = get_entvar(id, var_owner)), m_iNumSpawns) > CVAR[MAX])
	{
		client_print_color(activator, print_team_red, "^3этого игрока уже воскрешали в этом раунде..");
		return;
	}
	
	if (get_member(activator, m_iTeam) == get_entvar(id, var_team))
	{
		if (eCorpseStruct[activator][REVIVES] >= CVAR[MAX_REVIVES])
		{
			client_print_color(activator, print_team_red, "^3вы превысили лимит воскрешений за раунд");
			return;
		}
		
		set_dhudmessage(0, 160, 30, -1.0, 0.84, 2, 3.0, 2.0, 0.03, 0.4);
		
		show_dhudmessage(caller, "Вас воскрешает %n..", activator);
		show_dhudmessage(activator, "Вы воскрешаете %n..", caller);
		
		// set_entvar(caller, var_iuser1, OBS_IN_EYE);
		rg_internal_cmd(caller, "specmode", "4");
		set_entvar(caller, var_iuser2, activator);
		
		set_member(caller, m_hObserverTarget, activator);
		set_member(caller, m_flNextObserverInput, flCurTime + 1.6);
	}
	else
	{
		if (eCorpseStruct[activator][MINES] >= CVAR[MAX_MINES])
		{
			client_print_color(activator, print_team_red, "^3вы превысили лимит минирований за раунд");
			return;
		}
		
		if (get_entvar(id, var_iuser2))
		{
			client_print_color(activator, print_team_red, "^3этот труп уже заминирован..");
			return;
		}
		
		set_dhudmessage(0, 160, 30, -1.0, 0.76, 2, 3.0, 2.0, 0.03, 0.4);
		show_dhudmessage(activator, "Вы минируете %n..", caller);
	}
	
	// это просто фишка
	set_entvar(activator, var_iuser3, get_entvar(activator, var_iuser3) | PLAYER_PREVENT_CLIMB);
	
	if (CVAR[BAR])
		rg_send_bartime(activator, floatround(CVAR[DURATION]));
	
	if (CVAR[SPEED])
		rg_reset_maxspeed(activator);
	
	if (CVAR[CANT_FIRE])
		set_member(activator, m_bIsDefusing, true);
	
	set_entvar(id, var_iuser1, activator);
	set_entvar(id, var_fuser1, flCurTime + CVAR[DURATION]);
	set_entvar(id, var_nextthink, flCurTime + 0.2);
	
	if (CVAR[ALPHA])
	{
		UTIL_Render(id,
			.mode = kRenderTransAlpha,
			.flColor = Float:{ 200.0, 200.0, 200.0 },
			.iAmount = 200.0
		);
	}
	
	set_entvar(activator, var_velocity, NULL_VECTOR);
}

@corpse_think(id)
{
	if (is_nullent(id))
		return;
	
	new pActivator = get_entvar(id, var_iuser1);
	
	static Float:f1[3], Float:f2[3];
	get_entvar(id, var_origin, f1);
	get_entvar(pActivator, var_origin, f2);
	
	if (get_member_game(m_bRoundTerminating)
		|| m_bBombPlanted && CVAR[BOMB]
		|| UTIL_Is_1v1() && CVAR[DUEL]
		|| get_entvar(pActivator, var_deadflag) != DEAD_NO
		|| ~get_entvar(pActivator, var_button) & IN_USE
		|| vector_distance(f1, f2) > CVAR[DISTANCE]
	)
	{
		set_entvar(id, var_iuser1, 0);
		set_entvar(id, var_fuser1, 0.0);
		set_entvar(id, var_nextthink, 0.0);
		
		UTIL_Render(id);
		
		ResetRestrictions(pActivator);
		
		client_print_color(pActivator, print_team_red, "^3возрождение\минирование прервано..");
		
		return;
	}
	
	static Float:flCurTime;
	flCurTime = get_entvar(id, var_fuser1);
	
	if ((flCurTime != 0.0 && get_gametime() >= flCurTime))
	{
		new owner = get_entvar(id, var_owner);
		
		if (get_member(pActivator, m_iTeam) != get_entvar(id, var_team))
		{
			set_entvar(id, var_iuser1, 0);
			set_entvar(id, var_iuser2, 1);
			
			UTIL_Render(id);
			
		#if defined MINED_SAMPLE
			rh_emit_sound2(pActivator, 0, CHAN_BODY, MINED_SAMPLE);
		#endif

			client_print_color(pActivator, print_team_default, "труп^3 %n^1 успешно заминирован.", owner);
			
			eCorpseStruct[pActivator][MINES]++;
			
			// FIXES
			ResetRestrictions(pActivator);
		}
		else
		{
			if (get_entvar(id, var_iuser2))
			{
				rg_spawn_random_gibs(id, 5);
				
				message_begin_f(MSG_PVS, SVC_TEMPENTITY, f1);
				{
					write_byte(TE_EXPLOSION);
					write_coord_f(f1[0]);
					write_coord_f(f1[1]);
					write_coord_f(f1[2]);
					write_short(g_iSpriteIndex);
					write_byte(30);
					write_byte(20);
					write_byte(TE_EXPLFLAG_NOPARTICLES);
				}
				message_end();
				
				for (new i = 1, Float:flDistance; i <= MaxClients; i++)
				{
					if (!is_user_alive(i))
						continue;
					
					if (!rg_is_player_can_takedamage(i, pActivator))
						continue;
					
					get_entvar(i, var_origin, f2);
					if ((flDistance = vector_distance(f1, f2)) > 150.0)
						continue;
					
					ExecuteHamB(Ham_TakeDamage, i, 0, 0, (CVAR[DAMAGE] - flDistance * (CVAR[DAMAGE] / 150.0)), DMG_ALWAYSGIB);
				}
				
				client_print_color(pActivator, print_team_red, "^3труп был заминирован.");
			}
			else
			{
				set_member(owner, m_bNotKilled, true);
				
				rg_round_respawn(owner);
				{
					engfunc(EngFunc_SetOrigin, owner, f1);
					
					set_entvar(owner, var_flags, get_entvar(owner, var_flags) | FL_DUCKING);
					set_entvar(owner, var_view_ofs, Float:{ 0.0, 0.0, 12.0 });
				}
				
				set_entvar(owner, var_health, CVAR[HEALTH]);
				
				if (CVAR[GUN][0])
				{
					new szWeapon[17];
					while ((argbreak(CVAR[GUN], szWeapon, charsmax(szWeapon), CVAR[GUN], charsmax(CVAR[GUN]))) != INVALID_HANDLE)
						rg_give_item(owner, fmt("weapon_%s", szWeapon));
				}
				else
					rg_give_default_items(owner);
				
				ExecuteHamB(Ham_AddPoints, pActivator, CVAR[FRAG], true);
				ExecuteHamB(Ham_TakeHealth, pActivator, CVAR[ADD_HEALTH], DMG_GENERIC);
				
				client_print_color(0, pActivator, "^3%n^1 оклимал^3 %n", pActivator, owner);
				
			#if defined REVIVE_SAMPLE
				rh_emit_sound2(pActivator, 0, CHAN_BODY, REVIVE_SAMPLE);
			#endif
				
				rg_add_account(pActivator, -CVAR[MONEY]);
				
				eCorpseStruct[pActivator][REVIVES]++;
			}
			
			CorpseRemove(owner);
		}
	}
	else
		set_entvar(id, var_nextthink, get_gametime() + 0.2);
}

ResetRestrictions(pActivator)
{
	if (pActivator <= 0)
		return;
	
	set_entvar(pActivator, var_iuser3, get_entvar(pActivator, var_iuser3) & ~PLAYER_PREVENT_CLIMB);
	
	if (CVAR[CANT_FIRE])
		set_member(pActivator, m_bIsDefusing, false);

	if (CVAR[SPEED])
		rg_reset_maxspeed(pActivator);
	
	if (CVAR[BAR])
		rg_send_bartime(pActivator, 0);
}

public MsgHookClCorpse()
{
	if (get_member_game(m_iTotalRoundsPlayed) + 1 < CVAR[ROUND])
		return PLUGIN_CONTINUE;
	
	new id = rg_create_entity("info_target");
	
	if (is_nullent(id))
		return PLUGIN_CONTINUE;
	
	// владелец тела
	new pPlayer = get_msg_arg_int(12);
	
	eCorpseStruct[pPlayer][CORPSE_ID] = id;
	
	new Float:vecOrigin[3];
	new Float:vecAngles[3];
	
	for (new i; i < 3; i++)
	{
		vecOrigin[i] = float(get_msg_arg_int(2 + i)) / 128.0;
		vecAngles[i] = get_msg_arg_float(5 + i);
	}
	
	new szModel[32];
	get_msg_arg_string(1, szModel, charsmax(szModel));
	
	engfunc(EngFunc_SetModel, id, fmt("models/player/%s/%s.mdl", szModel, szModel));
	engfunc(EngFunc_SetSize, id, Float:{ -30.0, -30.0, -30.0 }, Float:{ 30.0, 30.0, 30.0 });
	engfunc(EngFunc_SetOrigin, id, vecOrigin);
	
	set_entvar(id, var_classname, CORPSE_CLASSNAME);
	set_entvar(id, var_angles, vecAngles);
	set_entvar(id, var_body, get_msg_arg_int(10));
	set_entvar(id, var_framerate, 1.0);
	set_entvar(id, var_animtime, 0.0);
	set_entvar(id, var_sequence, get_msg_arg_int(9));
	set_entvar(id, var_owner, pPlayer);
	set_entvar(id, var_team, get_msg_arg_int(11));
	
	// custom values
	set_entvar(id, var_iuser1, 0);
	set_entvar(id, var_iuser2, 0);
	set_entvar(id, var_fuser1, 0.0);
	
	// корень
	{
		SetUse(id, "@corpse_use");
		SetThink(id, "@corpse_think");
	}
	
	return PLUGIN_HANDLED;
}

CorpseRemove(pPlayer)
{
	new id = eCorpseStruct[pPlayer][CORPSE_ID];
	{
		arrayset(eCorpseStruct[pPlayer], 0, CORPSE_DATA);
	}
	
	if (is_nullent(id))
		return;
	
	ResetRestrictions(get_entvar(id, var_iuser1));
	
	set_entvar(id, var_flags, FL_KILLME);
}

CreateCvars()
{
	// $ddir/addons/amxmodx/configs/plugins/revive_teammates.cfg
	// файл создастся сам автоматически с вполне оптимальными настройками
	{
		bind_pcvar_string(create_cvar(
			"rt_access",
			"",
			.description = "Флаг(и) доступа [^"^" - всем]"),
			CVAR[ACCESS], charsmax(CVAR[ACCESS])
		);
		
		bind_pcvar_float(create_cvar(
			"rt_duration",
			"5.0",
			.description = "Время через которое воскреснит союзник [в секундах]",
			.has_min = true, .min_val = 1.0,
			.has_max = true, .max_val = 10.0),
			CVAR[DURATION]
		);	
		
		bind_pcvar_float(create_cvar(
			"rt_round_time",
			"15.0",
			.description = "Через сколько времени от начала раунда это будет доступно",
			.has_max = true, .max_val = 60.0),
			CVAR[ROUND_TIME]
		);
		
		bind_pcvar_num(create_cvar(
			"rt_round",
			"3",
			.description = "С какого раунда это доступно"),
			CVAR[ROUND]
		);
		
		bind_pcvar_num(create_cvar(
			"rt_max_spawns",
			"1",
			.description = "Максимальное кол-во раз сколько может воскреснуть/заминирован игрок за раунд",
			.has_min = true, .min_val = 1.0),
			CVAR[MAX]
		);
		
		bind_pcvar_num(create_cvar(
			"rt_max_revives",
			"1",
			.description = "Максимальное кол-во раз сколько может воскрешатьигрок за раунд"),
			CVAR[MAX_REVIVES]
		);
		
		bind_pcvar_num(create_cvar(
			"rt_max_mines",
			"1",
			.description = "Максимальное кол-во раз сколько может минировать игрок за раунд"),
			CVAR[MAX_MINES]
		);
		
		bind_pcvar_float(create_cvar(
			"rt_distance",
			"150.0",
			.description = "Максимальная допустимая дистанция",
			.has_min = true, .min_val = 64.0,
			.has_max = true, .max_val = 350.0),
			CVAR[DISTANCE]
		);
		
		bind_pcvar_num(create_cvar(
			"rt_money",
			"500",
			.description = "Стоимость услуги"),
			CVAR[MONEY]
		);
		
		bind_pcvar_num(create_cvar(
			"rt_frag",
			"1",
			.description = "Сколько даем фрагов тому кто поднял тиммейта?"),
			CVAR[FRAG]
		);
		
		bind_pcvar_float(create_cvar(
			"rt_bonus_health",
			"5.0",
			.description = "Сколько добовляем HP тому кто поднял тиммейта"),
			CVAR[ADD_HEALTH]
		);
		
		bind_pcvar_float(create_cvar(
			"rt_health",
			"50.0",
			.description = "Здоровье воскрешенного игрока",
			.has_min = true, .min_val = 1.0,
			.has_max = true, .max_val = 255.0),
			CVAR[HEALTH]
		);
		
		bind_pcvar_string(create_cvar(
			"rt_weapon",
			"knife deagle",
			.description = "Оружие воскрешенного игрока [^"^" - используем экипировку по умолчанию]"),
			CVAR[GUN], charsmax(CVAR[GUN])
		);
		
		bind_pcvar_num(create_cvar(
			"rt_bar",
			"1",
			.description = "Линия прогресса^n^n0. нет^n1. да",
			.has_max = true, .max_val = 2.0),
			CVAR[BAR]
		);
		
		bind_pcvar_num(create_cvar(
			"rt_bomb",
			"1",
			.description = "Блокируем возрождения когда бобма установленна?",
			.has_max = true, .max_val = 1.0),
			CVAR[BOMB]
		);
		
		bind_pcvar_num(create_cvar(
			"rt_1v1",
			"1",
			.description = "Блокируем возрождения когда остались 1vs1?"),
			CVAR[DUEL]
		);
		
		bind_pcvar_num(create_cvar(
			"rt_vip",
			"1",
			.description = "Блокируем возрождения для VIP игроков?"),
			CVAR[VIP]
		);
		
		bind_pcvar_num(create_cvar(
			"rt_cant_fire",
			"0",
			.description = "Заблокировать стрельбу во время события?"),
			CVAR[CANT_FIRE]
		);
		
		bind_pcvar_float(create_cvar(
			"rt_damage",
			"200.0",
			.description = "Урон от взрыва заминированного трупа (будет изменяться в зависимости от радиуса)",
			.has_min = true, .min_val = 64.0, .has_max = true, .max_val = 260.0),
			CVAR[DAMAGE]
		);
		
		bind_pcvar_float(create_cvar(
			"rt_speed",
			"200.0",
			.description = "Скорость во время события [0 - будет неизменной]",
			.has_max = true, .max_val = 260.0),
			CVAR[SPEED]
		);
		
		bind_pcvar_float(create_cvar(
			"rt_alpha",
			"200.0",
			.description = "Степень прозрачности трупа во время возрождения/минирования [0 - выкл]",
			.has_min = true,
			.has_max = true, .max_val = 255.0),
			CVAR[ALPHA]
		);
	}
	
	if (CVAR[SPEED])
		RegisterHookChain(RG_CBasePlayer_ResetMaxSpeed, "CBasePlayer_ResetMaxSpeed", true);
	
	register_cvar("revive_teammates", VERSION, FCVAR_SERVER | FCVAR_SPONLY);
	
	AutoExecConfig(.name = "revive_teammates");
}

stock bool:UTIL_Is_1v1()
{
	new iAliveT, iAliveCT;
	rg_initialize_player_counts(iAliveT, iAliveCT, _, _);

	return bool:(iAliveT == 1 && iAliveCT == 1);
}

stock UTIL_Render(const id, const fx = kRenderFxNone, const mode = kRenderNormal, const Float:flColor[] = NULL_VECTOR, const Float:iAmount = 0.0)
{
	set_entvar(id, var_renderfx, fx);
	set_entvar(id, var_rendermode, mode);
	set_entvar(id, var_rendercolor, flColor);
	set_entvar(id, var_renderamt, iAmount);
}

